module Trimble
module MaterialResizer
@@debug = false
def MaterialResizer.isMac
  (RUBY_PLATFORM.downcase =~ /darwin/) != nil
end
def MaterialResizer.isDebug?
  @@debug
end
end
end

#Sketchup::load 'MaterialResizer/MaterialResizerActions'
load Sketchup.find_support_file('MaterialResizerActions.rb', 'Plugins/MaterialResizer')

module Trimble
module MaterialResizer
def MaterialResizer.tempDir
  ret = ""
  if ENV["TEMP"]
    ret = ENV["TEMP"]  # Windows
  elsif ENV["TMPDIR"]
    ret = ENV["TMPDIR"]  # Mac (from what I can tell)
  elsif File.exists?("/tmp")
    ret = "/tmp"   # Mac fallback
  end
  return ret.gsub(/\\/, '/')  # Fix slashes
end

def MaterialResizer.setupUI
    # Add tool item
    cmdMatResize = UI::Command.new("MatResizer") {
      MaterialResizerActions.showUI
    }
    cmdMatResize.small_icon = cmdMatResize.large_icon = "images/MaterialResizer.png"
    cmdMatResize.tooltip = cmdMatResize.status_bar_text = "Resize all materials"
    cmdMatResize.menu_text = "Material Resizer"

    cmdMatReload = UI::Command.new("MatResizer") {
      load Sketchup.find_support_file('MaterialResizerActions.rb', 'Plugins/MaterialResizer')
    }
    cmdMatReload.small_icon = cmdMatReload.large_icon = "images/MaterialResizer.png"
    cmdMatReload.tooltip = cmdMatReload.status_bar_text = "Reload Material Resizer"
    cmdMatReload.menu_text = "Reload Resize Materials"

    UI.menu.add_item cmdMatResize
    UI.menu.add_item cmdMatReload if Trimble::MaterialResizer.isDebug?
end
MaterialResizer.setupUI
end
end
