function uiaction(val) {
    window.location = 'skp:uiaction@' + val;
}
$(function() { 
  uiaction("loaded")
});

g_isDebug = false;
g_Mats = [];
function loadComplete(isDebug) {
    g_isDebug = isDebug;
    if (!g_isDebug) {
        document.oncontextmenu = function(e) { return false; };
    } else {
        $(".debug").show();
    }
    $("#advanced").hide();
    onHeaderCheck.indeterminateGroup = undefined;
    loadSettings();
}
function loadSettings() {
    // Check for materails
    uiaction("loadsettings");
}

function setSettings(mats) {
  g_Mats = mats;
  updateMatList();
}

function updateMatList() {
  var matList = $("#matlist");
  var allMats = g_Mats["all"];
  var newHtml = '<thead><th class="checkcol"><input type="checkbox" id="headercheck" onclick="onHeaderCheck();"></th><th class="namecol">Material Name</th><th class="sizecol" onclick="onFilter();">Size</th></thead>';
  allMats.sort(function(a, b) {
    var aval = Math.max(a["w"], a["h"]);
    var bval = Math.max(b["w"], b["h"]);
    if (aval < bval) return 1;
    if (aval > bval) return -1;
    aval = a["name"];
    bval = b["name"];
    if (aval < bval) return -1;
    if (aval > bval) return 1;
    return 0;
  });
  var filterSize = $("#filtersize").val();
  for (var idx in allMats) {
    var m = allMats[idx];
    if (m["w"] < filterSize && m["h"] < filterSize) continue;
    newHtml += '<tr><td class="checkcol"><input class="matcheck" id="matcheck_' + idx + '" type="checkbox" onclick="onMatCheck(' + idx + ');" value="' + m["id"] + '"></td><td class="namecol"><label for="matcheck_' + idx + '"><p class="matname"><img src="data:image/png;base64,' + m["img"] + '">' + m["name"] + '</p></label></td><td class="sizecol">' + m["w"] + 'x' + m["h"] + '</td></tr>';
  }
  matList.html(newHtml);
}

function onFilter() {
  $("#filter").toggle();
  $("#disable").toggle();
  if ($("#filter").is(":visible")) {
    $("#filtersize").focus();
    $("#filtersize").select();
  }
}

function onFilterDone() {
  if ($("#filter").is(":visible")) {
    $("#filter").hide();
    $("#disable").hide();
    $("#matsize").val(Math.max($("#matsize").val(), $("#filtersize").val()));
  }
}

function onDisableClicked() {
  onFilterDone();
}

function onMatFilterChange() {
  updateMatList();
}

function onMatFilterKeyPress(e) {
  updateMatList();
  if (e.keyCode == 13) {
    onFilterDone();
  }
}

function onMatCheck(idx) {
  var hasChecked = $(".matcheck").is(":checked");
  var allChecked = $(".matcheck").not(":checked").size() == 0;
  if (hasChecked && !allChecked) {
    $("#headercheck").prop("indeterminate", true);
    $("#headercheck").prop("readOnly", true);
    $("#headercheck").prop("checked", false);
    onHeaderCheck.indeterminateGroup = $(".matcheck").filter(":checked");
  } else if (allChecked) {
    $("#headercheck").prop("indeterminate", false);
    $("#headercheck").prop("readOnly", false);
    $("#headercheck").prop("checked", true);
    onHeaderCheck.indeterminateGroup = undefined;
  } else {
    $("#headercheck").prop("indeterminate", false);
    $("#headercheck").prop("readOnly", false);
    $("#headercheck").prop("checked", false);
    onHeaderCheck.indeterminateGroup = undefined;
  }
}

function onHeaderCheck() {
  if (onHeaderCheck.indeterminateGroup) {
    // Use indeterminate swap
    var cb = $("#headercheck")[0];
    if (cb.readOnly) {
      cb.checked=cb.readOnly=false;
    } else if (!cb.checked) { 
      cb.readOnly=cb.indeterminate=true;
    }
    if (cb.checked || !cb.indeterminate) {
      // Otherwise just update the children
      $(".matcheck").prop("checked", cb.checked);
    } else {
      $(".matcheck").prop("checked", false);
      onHeaderCheck.indeterminateGroup.prop("checked", true);
    }
 } else { 
    // Otherwise just update the children
    $(".matcheck").prop("checked", $("#headercheck").prop("checked"));
  }

}

function onCancel() {
  uiaction("close");
}

function onOK() {
  uiaction("resize;" + $("#matsize").val() + ";" + $(".matcheck").filter(":checked").map(function (idx, elem) { return elem.value; }).get().join(";"));
  
}